Subject: [PATCH 7/8] memory: emif: errata i743: Prohibit usage of Power-Down mode

From: [email-masked] (Santosh Shilimkar)
Date: Mon, 11 Mar 2013 11:20:05 +0530

On Monday 11 March 2013 10:36 AM, Lokesh Vutla wrote:
> From: Grygorii Strashko <[email-masked]>
> 
> ERRATA DESCRIPTION :
> The EMIF supports power-down state for low power. The EMIF
> automatically puts the SDRAM into power-down after the memory is
> not accessed for a defined number of cycles and the
> EMIF_PWR_MGMT_CTRL[10:8] REG_LP_MODE bit field is set to 0x4.
> As the EMIF supports automatic output impedance calibration, a ZQ
> calibration long command is issued every time it exits active
> power-down and precharge power-down modes. The EMIF waits and
> blocks any other command during this calibration.
> The EMIF does not allow selective disabling of ZQ calibration upon
> exit of power-down mode. Due to very short periods of power-down
> cycles, ZQ calibration overhead creates bandwidth issues and
> increases overall system power consumption. On the other hand,
> issuing ZQ calibration long commands when exiting self-refresh is
> still required.
> 
> WORKAROUND :
> Because there is no power consumption benefit of the power-down due
> to the calibration and there is a performance risk, the guideline
> is to not allow power-down state and, therefore, to not have set
> the EMIF_PWR_MGMT_CTRL[10:8] REG_LP_MODE bit field to 0x4.
> 
> Signed-off-by: Grygorii Strashko <[email-masked]>
> Signed-off-by: Vitaly Chernooky <[email-masked]>
> Signed-off-by: Oleksandr Dmytryshyn <[email-masked]>
> Signed-off-by: Lokesh Vutla <[email-masked]>
> ---
Nice changelog.

>  drivers/memory/emif.c |   35 +++++++++++++++++++++++++++++++++++
>  1 file changed, 35 insertions(+)
> 
> diff --git a/drivers/memory/emif.c b/drivers/memory/emif.c
> index f75806a..119503a 100644
> --- a/drivers/memory/emif.c
> +++ b/drivers/memory/emif.c
> @@ -257,6 +257,41 @@ static void set_lpmode(struct emif_data *emif, u8 lpmode)
>  	u32 temp;
>  	void __iomem *base = emif->base;
>  
> +	/*
> +	 * Workaround for errata i743 - LPDDR2 Power-Down State is Not
> +	 * Efficient
> +	 *
> +	 * i743 DESCRIPTION:
> +	 * The EMIF supports power-down state for low power. The EMIF
> +	 * automatically puts the SDRAM into power-down after the memory is
> +	 * not accessed for a defined number of cycles and the
> +	 * EMIF_PWR_MGMT_CTRL[10:8] REG_LP_MODE bit field is set to 0x4.
> +	 * As the EMIF supports automatic output impedance calibration, a ZQ
> +	 * calibration long command is issued every time it exits active
> +	 * power-down and precharge power-down modes. The EMIF waits and
> +	 * blocks any other command during this calibration.
> +	 * The EMIF does not allow selective disabling of ZQ calibration upon
> +	 * exit of power-down mode. Due to very short periods of power-down
> +	 * cycles, ZQ calibration overhead creates bandwidth issues and
> +	 * increases overall system power consumption. On the other hand,
> +	 * issuing ZQ calibration long commands when exiting self-refresh is
> +	 * still required.
> +	 *
> +	 * WORKAROUND
> +	 * Because there is no power consumption benefit of the power-down due
> +	 * to the calibration and there is a performance risk, the guideline
> +	 * is to not allow power-down state and, therefore, to not have set
> +	 * the EMIF_PWR_MGMT_CTRL[10:8] REG_LP_MODE bit field to 0x4.
> +	 */
> +	if ((emif->plat_data->ip_rev == EMIF_4D) &&
> +	    (EMIF_LP_MODE_PWR_DN == lpmode)) {
Ok. So the errata is limited to only 'EMIF_4D' version and not applicable
for next EMIF version used in OMAP5 devices, right ? If yes, would be good
to just mention that in already good changelog.

> +		WARN_ONCE(1,
> +			  "REG_LP_MODE = LP_MODE_PWR_DN(4) is prohibited by"
> +			  "erratum i743 switch to LP_MODE_SELF_REFRESH(2)\n");
> +		/* rallback LP_MODE to Self-refresh mode */
s/rallback/rollback ?

With above updates,
Acked-by: Santosh Shilimkar <[email-masked]>